//#line 2 "/opt/ros/hydro/share/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the hark_params package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __hark_params__DYNRECONFHARKPARAMSCONFIG_H__
#define __hark_params__DYNRECONFHARKPARAMSCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace hark_params
{
  class DynReconfHarkParamsConfigStatics;
  
  class DynReconfHarkParamsConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(DynReconfHarkParamsConfig &config, const DynReconfHarkParamsConfig &max, const DynReconfHarkParamsConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const DynReconfHarkParamsConfig &config1, const DynReconfHarkParamsConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, DynReconfHarkParamsConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const DynReconfHarkParamsConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, DynReconfHarkParamsConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const DynReconfHarkParamsConfig &config) const = 0;
      virtual void getValue(const DynReconfHarkParamsConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T DynReconfHarkParamsConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (DynReconfHarkParamsConfig::* field);

      virtual void clamp(DynReconfHarkParamsConfig &config, const DynReconfHarkParamsConfig &max, const DynReconfHarkParamsConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const DynReconfHarkParamsConfig &config1, const DynReconfHarkParamsConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, DynReconfHarkParamsConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const DynReconfHarkParamsConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, DynReconfHarkParamsConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const DynReconfHarkParamsConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const DynReconfHarkParamsConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, DynReconfHarkParamsConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); i++)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    template<class T, class PT>
    class GroupDescription : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string name, std::string type, int parent, int id, bool s, T PT::* f) : AbstractGroupDescription(name, type, parent, id, s), field(f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;
        
        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++) 
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }
      
      virtual void updateParams(boost::any &cfg, DynReconfHarkParamsConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++) 
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); i++)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<DynReconfHarkParamsConfig::AbstractGroupDescriptionConstPtr> groups;
    };
    
class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(DynReconfHarkParamsConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = params.begin(); i != params.end(); i++)
      {
        boost::any val;
        (*i)->getValue(config, val);

        if("HarkParamsDynReconfEnable"==(*i)->name){HarkParamsDynReconfEnable = boost::any_cast<bool>(val);}
        if("LocalizeMUSIC_num_source"==(*i)->name){LocalizeMUSIC_num_source = boost::any_cast<int>(val);}
        if("LocalizeMUSIC_min_deg"==(*i)->name){LocalizeMUSIC_min_deg = boost::any_cast<int>(val);}
        if("LocalizeMUSIC_max_deg"==(*i)->name){LocalizeMUSIC_max_deg = boost::any_cast<int>(val);}
        if("LocalizeMUSIC_lower_bound_frequency"==(*i)->name){LocalizeMUSIC_lower_bound_frequency = boost::any_cast<int>(val);}
        if("LocalizeMUSIC_upper_bound_frequency"==(*i)->name){LocalizeMUSIC_upper_bound_frequency = boost::any_cast<int>(val);}
        if("SourceTracker_thresh"==(*i)->name){SourceTracker_thresh = boost::any_cast<double>(val);}
        if("SourceTracker_pause_length"==(*i)->name){SourceTracker_pause_length = boost::any_cast<double>(val);}
        if("SourceTracker_min_src_interval"==(*i)->name){SourceTracker_min_src_interval = boost::any_cast<double>(val);}
        if("SourceTracker_min_tfindex_interval"==(*i)->name){SourceTracker_min_tfindex_interval = boost::any_cast<double>(val);}
        if("SourceTracker_compare_mode"==(*i)->name){SourceTracker_compare_mode = boost::any_cast<int>(val);}
        if("HRLE_lx"==(*i)->name){HRLE_lx = boost::any_cast<double>(val);}
        if("HRLE_time_constant"==(*i)->name){HRLE_time_constant = boost::any_cast<double>(val);}
      }
    }

    bool HarkParamsDynReconfEnable;
int LocalizeMUSIC_num_source;
int LocalizeMUSIC_min_deg;
int LocalizeMUSIC_max_deg;
int LocalizeMUSIC_lower_bound_frequency;
int LocalizeMUSIC_upper_bound_frequency;
double SourceTracker_thresh;
double SourceTracker_pause_length;
double SourceTracker_min_src_interval;
double SourceTracker_min_tfindex_interval;
int SourceTracker_compare_mode;
double HRLE_lx;
double HRLE_time_constant;

    bool state;
    std::string name;

    
}groups;



//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      bool HarkParamsDynReconfEnable;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      int LocalizeMUSIC_num_source;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      int LocalizeMUSIC_min_deg;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      int LocalizeMUSIC_max_deg;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      int LocalizeMUSIC_lower_bound_frequency;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      int LocalizeMUSIC_upper_bound_frequency;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      double SourceTracker_thresh;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      double SourceTracker_pause_length;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      double SourceTracker_min_src_interval;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      double SourceTracker_min_tfindex_interval;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      int SourceTracker_compare_mode;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      double HRLE_lx;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      double HRLE_time_constant;
//#line 255 "/opt/ros/hydro/share/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("DynReconfHarkParamsConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const DynReconfHarkParamsConfig &__max__ = __getMax__();
      const DynReconfHarkParamsConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const DynReconfHarkParamsConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const DynReconfHarkParamsConfig &__getDefault__();
    static const DynReconfHarkParamsConfig &__getMax__();
    static const DynReconfHarkParamsConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();
    
  private:
    static const DynReconfHarkParamsConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void DynReconfHarkParamsConfig::ParamDescription<std::string>::clamp(DynReconfHarkParamsConfig &config, const DynReconfHarkParamsConfig &max, const DynReconfHarkParamsConfig &min) const
  {
    return;
  }

  class DynReconfHarkParamsConfigStatics
  {
    friend class DynReconfHarkParamsConfig;
    
    DynReconfHarkParamsConfigStatics()
    {
DynReconfHarkParamsConfig::GroupDescription<DynReconfHarkParamsConfig::DEFAULT, DynReconfHarkParamsConfig> Default("Default", "", 0, 0, true, &DynReconfHarkParamsConfig::groups);
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.HarkParamsDynReconfEnable = 0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.HarkParamsDynReconfEnable = 1;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.HarkParamsDynReconfEnable = 0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<bool>("HarkParamsDynReconfEnable", "bool", 0, "Enable dynamic reconf mode", "", &DynReconfHarkParamsConfig::HarkParamsDynReconfEnable)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<bool>("HarkParamsDynReconfEnable", "bool", 0, "Enable dynamic reconf mode", "", &DynReconfHarkParamsConfig::HarkParamsDynReconfEnable)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.LocalizeMUSIC_num_source = 1;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.LocalizeMUSIC_num_source = 7;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.LocalizeMUSIC_num_source = 2;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_num_source", "int", 0, "LocalizeMUSIC : NUM_SOURCE", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_num_source)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_num_source", "int", 0, "LocalizeMUSIC : NUM_SOURCE", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_num_source)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.LocalizeMUSIC_min_deg = -180;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.LocalizeMUSIC_min_deg = 180;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.LocalizeMUSIC_min_deg = -180;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_min_deg", "int", 0, "LocalizeMUSIC : MIN_DEG", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_min_deg)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_min_deg", "int", 0, "LocalizeMUSIC : MIN_DEG", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_min_deg)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.LocalizeMUSIC_max_deg = -180;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.LocalizeMUSIC_max_deg = 180;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.LocalizeMUSIC_max_deg = 180;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_max_deg", "int", 0, "LocalizeMUSIC : MAX_DEG", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_max_deg)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_max_deg", "int", 0, "LocalizeMUSIC : MAX_DEG", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_max_deg)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.LocalizeMUSIC_lower_bound_frequency = 0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.LocalizeMUSIC_lower_bound_frequency = 8000;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.LocalizeMUSIC_lower_bound_frequency = 500;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_lower_bound_frequency", "int", 0, "LocalizeMUSIC : LOWER_BOUND_FREQUENCY", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_lower_bound_frequency)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_lower_bound_frequency", "int", 0, "LocalizeMUSIC : LOWER_BOUND_FREQUENCY", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_lower_bound_frequency)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.LocalizeMUSIC_upper_bound_frequency = 0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.LocalizeMUSIC_upper_bound_frequency = 8000;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.LocalizeMUSIC_upper_bound_frequency = 2800;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_upper_bound_frequency", "int", 0, "LocalizeMUSIC : UPPER_BOUND_FREQUENCY", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_upper_bound_frequency)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("LocalizeMUSIC_upper_bound_frequency", "int", 0, "LocalizeMUSIC : UPPER_BOUND_FREQUENCY", "", &DynReconfHarkParamsConfig::LocalizeMUSIC_upper_bound_frequency)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.SourceTracker_thresh = 0.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.SourceTracker_thresh = 100.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.SourceTracker_thresh = 23.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_thresh", "double", 0, "SourceTracker : THRESH", "", &DynReconfHarkParamsConfig::SourceTracker_thresh)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_thresh", "double", 0, "SourceTracker : THRESH", "", &DynReconfHarkParamsConfig::SourceTracker_thresh)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.SourceTracker_pause_length = 0.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.SourceTracker_pause_length = 5000.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.SourceTracker_pause_length = 800.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_pause_length", "double", 0, "SourceTracker : PAUSE_LENGTH", "", &DynReconfHarkParamsConfig::SourceTracker_pause_length)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_pause_length", "double", 0, "SourceTracker : PAUSE_LENGTH", "", &DynReconfHarkParamsConfig::SourceTracker_pause_length)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.SourceTracker_min_src_interval = 0.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.SourceTracker_min_src_interval = 180.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.SourceTracker_min_src_interval = 20.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_min_src_interval", "double", 0, "SourceTracker : MIN_SRC_INTERVAL", "", &DynReconfHarkParamsConfig::SourceTracker_min_src_interval)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_min_src_interval", "double", 0, "SourceTracker : MIN_SRC_INTERVAL", "", &DynReconfHarkParamsConfig::SourceTracker_min_src_interval)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.SourceTracker_min_tfindex_interval = 0.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.SourceTracker_min_tfindex_interval = 36.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.SourceTracker_min_tfindex_interval = 6.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_min_tfindex_interval", "double", 0, "SourceTracker : MIN_TFINDEX_INTERVAL", "", &DynReconfHarkParamsConfig::SourceTracker_min_tfindex_interval)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("SourceTracker_min_tfindex_interval", "double", 0, "SourceTracker : MIN_TFINDEX_INTERVAL", "", &DynReconfHarkParamsConfig::SourceTracker_min_tfindex_interval)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.SourceTracker_compare_mode = 0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.SourceTracker_compare_mode = 1;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.SourceTracker_compare_mode = 0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("SourceTracker_compare_mode", "int", 0, "SourceTracker : COMPARE_MODE", "{'enum_description': 'An enum to set the compare mode.', 'enum': [{'srcline': 10, 'description': 'DEG', 'srcfile': '../cfg/DynReconfHarkParams.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'DEG'}, {'srcline': 11, 'description': 'TFINDEX', 'srcfile': '../cfg/DynReconfHarkParams.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'TFINDEX'}]}", &DynReconfHarkParamsConfig::SourceTracker_compare_mode)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<int>("SourceTracker_compare_mode", "int", 0, "SourceTracker : COMPARE_MODE", "{'enum_description': 'An enum to set the compare mode.', 'enum': [{'srcline': 10, 'description': 'DEG', 'srcfile': '../cfg/DynReconfHarkParams.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'DEG'}, {'srcline': 11, 'description': 'TFINDEX', 'srcfile': '../cfg/DynReconfHarkParams.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'TFINDEX'}]}", &DynReconfHarkParamsConfig::SourceTracker_compare_mode)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.HRLE_lx = 0.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.HRLE_lx = 1.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.HRLE_lx = 0.85;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("HRLE_lx", "double", 0, "HRLE : LX", "", &DynReconfHarkParamsConfig::HRLE_lx)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("HRLE_lx", "double", 0, "HRLE : LX", "", &DynReconfHarkParamsConfig::HRLE_lx)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __min__.HRLE_time_constant = 160.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __max__.HRLE_time_constant = 960000.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __default__.HRLE_time_constant = 16000.0;
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.abstract_parameters.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("HRLE_time_constant", "double", 0, "HRLE : TIME_CONSTANT", "", &DynReconfHarkParamsConfig::HRLE_time_constant)));
//#line 259 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __param_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr(new DynReconfHarkParamsConfig::ParamDescription<double>("HRLE_time_constant", "double", 0, "HRLE : TIME_CONSTANT", "", &DynReconfHarkParamsConfig::HRLE_time_constant)));
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      Default.convertParams();
//#line 233 "/opt/ros/hydro/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator.py"
      __group_descriptions__.push_back(DynReconfHarkParamsConfig::AbstractGroupDescriptionConstPtr(new DynReconfHarkParamsConfig::GroupDescription<DynReconfHarkParamsConfig::DEFAULT, DynReconfHarkParamsConfig>(Default)));
//#line 390 "/opt/ros/hydro/share/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<DynReconfHarkParamsConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__); 
    }
    std::vector<DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<DynReconfHarkParamsConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    DynReconfHarkParamsConfig __max__;
    DynReconfHarkParamsConfig __min__;
    DynReconfHarkParamsConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const DynReconfHarkParamsConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static DynReconfHarkParamsConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &DynReconfHarkParamsConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const DynReconfHarkParamsConfig &DynReconfHarkParamsConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const DynReconfHarkParamsConfig &DynReconfHarkParamsConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const DynReconfHarkParamsConfig &DynReconfHarkParamsConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<DynReconfHarkParamsConfig::AbstractParamDescriptionConstPtr> &DynReconfHarkParamsConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<DynReconfHarkParamsConfig::AbstractGroupDescriptionConstPtr> &DynReconfHarkParamsConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const DynReconfHarkParamsConfigStatics *DynReconfHarkParamsConfig::__get_statics__()
  {
    const static DynReconfHarkParamsConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = DynReconfHarkParamsConfigStatics::get_instance();
    
    return statics;
  }

//#line 10 "../cfg/DynReconfHarkParams.cfg"
      const int DynReconfHarkParams_DEG = 0;
//#line 11 "../cfg/DynReconfHarkParams.cfg"
      const int DynReconfHarkParams_TFINDEX = 1;
}

#endif // __DYNRECONFHARKPARAMSRECONFIGURATOR_H__
